/*
 * CommandLineParser_validate.hpp
 *
 *  Created on: Nov 8, 2010
 *      Author: heber
 */

#ifndef COMMANDLINEPARSER_VALIDATE_HPP_
#define COMMANDLINEPARSER_VALIDATE_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <vector>
#include <iosfwd>

#include <boost/program_options.hpp>
#include <boost/filesystem.hpp>
#include <boost/lexical_cast.hpp>

struct KeyValuePair;
class RealSpaceMatrixValue;
class VectorValue;

void validate(boost::any& v, const std::vector<std::string>& values, KeyValuePair *, int);
void validate(boost::any& v, const std::vector<std::string>& values, std::vector<KeyValuePair> *, int);
void validate(boost::any& v, const std::vector<std::string>& values, VectorValue *, int);
void validate(boost::any& v, const std::vector<std::string>& values, RealSpaceMatrixValue *, int);
void validate(boost::any& v, const std::vector<std::string>& values, boost::filesystem::path *, int);

#endif /* COMMANDLINEPARSER_VALIDATE_HPP_ */
